#include <stdio.h>
#include <stdlib.h>

#include <windows.h>
#include "stream/stream.h"
#include "libmpdemux/demuxer.h"
#include "libmpdemux/stheader.h"

int main(int argc, char* argv[])
{
	stream_t* stream = NULL;
	demuxer_t* _demuxer = NULL;
	demuxer_t demuxer;
	char* filename = "d:\\Music\\01.mp3";
	int file_format = 0;

	sh_audio_t *sh_audio = NULL;
    sh_video_t *sh_video = NULL;
    demux_stream_t *d_audio = NULL;
    demux_stream_t *d_video = NULL;

	HMODULE hModule = LoadLibrary("mplayer.dll");

	if(hModule)
	{
		typedef void* (__stdcall *open_stream)(char* filename,char** options,int* file_format);
		typedef void* (__stdcall *demux_open)(void *stream,int file_format,int aid,int vid,int sid,char* filename);

		open_stream _open_stream = (open_stream)GetProcAddress(hModule, "exp_open_stream@12");
		demux_open _demux_open = (demux_open)GetProcAddress(hModule, "exp_demux_open@24");

		printf("%p %p\n", _open_stream, _demux_open);

		stream = (stream_t*)_open_stream(filename, 0, &file_format);
		_demuxer = (demuxer_t*)_demux_open(stream, file_format, -1, -1, -1, filename);
		memcpy(&demuxer, _demuxer, sizeof(demuxer_t));

		d_audio=demuxer.audio;
		d_video=demuxer.video;

		if(d_audio)
			sh_audio=d_audio->sh;

		printf("stream=%p, demuxer=%p, d_audio=%p, d_video=%p, sh_audio=%p\n",
			stream, &demuxer, d_audio, d_video, sh_audio);

		
		FreeLibrary(hModule);
	}
	return 0;
}
